searchNodes=[{"doc":"A set of process-less functions for forming A2S challenges, requests, and parsing responses.","ref":"A2S.html","title":"A2S","type":"module"},{"doc":"","ref":"A2S.html#challenge_request/1","title":"A2S.challenge_request/1","type":"function"},{"doc":"Parses a challenge response payload. Some game servers don't implement the challenge flow and will immediately respond with the requested data. In that case :immediate will be returned with the data. If the server returns data immediately, and that data is multipart, :multipart will be returned.","ref":"A2S.html#parse_challenge/1","title":"A2S.parse_challenge/1","type":"function"},{"doc":"","ref":"A2S.html#parse_multipacket_response/1","title":"A2S.parse_multipacket_response/1","type":"function"},{"doc":"","ref":"A2S.html#parse_response/1","title":"A2S.parse_response/1","type":"function"},{"doc":"","ref":"A2S.html#sign_challenge/2","title":"A2S.sign_challenge/2","type":"function"},{"doc":"An easy to use client that performs the handshaking and busy-work necessary to make execute A2S queries. This client handles requests concurrently and should be suitable for most general uses. Note: must supply a :name","ref":"A2S.Client.html","title":"A2S.Client","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"A2S.Client.html#child_spec/1","title":"A2S.Client.child_spec/1","type":"function"},{"doc":"Query a game server running at address for the data specified by query .","ref":"A2S.Client.html#query/3","title":"A2S.Client.query/3","type":"function"},{"doc":"","ref":"A2S.Client.html#start_link/1","title":"A2S.Client.start_link/1","type":"function"},{"doc":"Struct representing an A2S_INFO response.","ref":"A2S.Info.html","title":"A2S.Info","type":"module"},{"doc":"","ref":"A2S.Info.html#t:t/0","title":"A2S.Info.t/0","type":"type"},{"doc":"Struct representing a multi-packet response header .","ref":"A2S.MultiPacketHeader.html","title":"A2S.MultiPacketHeader","type":"module"},{"doc":"","ref":"A2S.MultiPacketHeader.html#t:t/0","title":"A2S.MultiPacketHeader.t/0","type":"type"},{"doc":"Struct representing a player entry in an A2S_PLAYER response.","ref":"A2S.Player.html","title":"A2S.Player","type":"module"},{"doc":"","ref":"A2S.Player.html#t:t/0","title":"A2S.Player.t/0","type":"type"},{"doc":"Struct representing an A2S_PLAYER response.","ref":"A2S.Players.html","title":"A2S.Players","type":"module"},{"doc":"","ref":"A2S.Players.html#t:t/0","title":"A2S.Players.t/0","type":"type"},{"doc":"Struct representing a rule in an A2S_RULES response.","ref":"A2S.Rule.html","title":"A2S.Rule","type":"module"},{"doc":"","ref":"A2S.Rule.html#t:t/0","title":"A2S.Rule.t/0","type":"type"},{"doc":"Struct representing an A2S_RULES response.","ref":"A2S.Rules.html","title":"A2S.Rules","type":"module"},{"doc":"","ref":"A2S.Rules.html#t:t/0","title":"A2S.Rules.t/0","type":"type"},{"doc":"Singleton dynamic supervisor for A2S.Statem processes.","ref":"A2S.DynamicSupervisor.html","title":"A2S.DynamicSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"A2S.DynamicSupervisor.html#child_spec/1","title":"A2S.DynamicSupervisor.child_spec/1","type":"function"},{"doc":"Starts an A2S.Statem for the specified address .","ref":"A2S.DynamicSupervisor.html#start_child/1","title":"A2S.DynamicSupervisor.start_child/1","type":"function"},{"doc":"","ref":"A2S.DynamicSupervisor.html#start_link/1","title":"A2S.DynamicSupervisor.start_link/1","type":"function"},{"doc":"A state machine process responsible for handling all A2S queries to a game server running at the given address. Queries must be performed sequentially per address, as A2S provides no way to associate what replies associate to what responses. Each instance should exit normally after a certain interval of inactivity (currently hard-coded to 2 minutes).","ref":"A2S.Statem.html","title":"A2S.Statem","type":"module"},{"doc":"","ref":"A2S.Statem.html#child_spec/1","title":"A2S.Statem.child_spec/1","type":"function"},{"doc":"","ref":"A2S.Statem.html#start_link/1","title":"A2S.Statem.start_link/1","type":"function"},{"doc":"","ref":"A2S.Statem.html#stop/2","title":"A2S.Statem.stop/2","type":"function"},{"doc":"","ref":"A2S.Statem.html#t:init_args/0","title":"A2S.Statem.init_args/0","type":"type"},{"doc":"GenServer wrapper over :gen_udp , responsible for sending packets to game-servers and routing received packets to the appropriate A2S.Statem process.","ref":"A2S.UDP.html","title":"A2S.UDP","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"A2S.UDP.html#child_spec/1","title":"A2S.UDP.child_spec/1","type":"function"},{"doc":"Send the given msg packet to the game server.","ref":"A2S.UDP.html#handle_call/3","title":"A2S.UDP.handle_call/3","type":"function"},{"doc":"Forward received packets to the appropriate A2S.Statem .","ref":"A2S.UDP.html#handle_info/2","title":"A2S.UDP.handle_info/2","type":"function"},{"doc":"","ref":"A2S.UDP.html#start_link/1","title":"A2S.UDP.start_link/1","type":"function"},{"doc":"A library for communicating with game servers running Valve's A2S server query protocol .","ref":"readme.html","title":"Elixir A2S","type":"extras"},{"doc":"The package can be installed by adding a2s to your list of dependencies in mix.exs : def deps do [ { :elixir_a2s , &quot;~&gt; 0.2.5&quot; } ] end Documentation is available on HexDocs and may also be generated with ExDoc .","ref":"readme.html#installation","title":"Elixir A2S - Installation","type":"extras"},{"doc":"There's two general ways to use this library: Via A2S.Client An easy to use client that should cover most use-cases. Add A2S.Client to your app's supervision tree: children = [ {A2S.Client, [name: MyA2SCli]} ] Or start the client dynamically: A2S.Client.start_link([name: MyA2SCli]) Afterwards querying a game server's as simple as: A2S.Client.query(:info, {{127, 0, 0, 1}, 20000}) # ipv4 address followed by port Via A2S This module provides the means form requests, sign challenges, and parse responses for the A2S protocol. You can utilize this module directly in your application for tighter integration, but in turn you'll have to handle the networking or handshaking necessary to execute A2S queries. See Using A2S Directly guide for further details.","ref":"readme.html#usage","title":"Elixir A2S - Usage","type":"extras"},{"doc":"The following configuration options are available for A2S.Client : :name - Required, used as the name of the top-level supervisor for A2S.Client :port - Port on which to open the UDP socket for communicating with game servers. Defaults to 20850 . :idle_timeout - Under the hood, A2S.Client spins up one :gen_statem processes per address queried. These serve two purposes - to handle all the hand-shaking and packet wrangling necessary to complete A2S queries, and to ensure queries are executed sequentially. After an address hasn't been queried for an extended period, these processes should terminate to free their memory. Defaults to 120_000 (2 minutes, expressed in milliseconds). :recv_timeout - Deadline to receive a response packet for each packet sent in the query sequence. Defaults to 3000 (3 seconds, expressed in milliseconds).","ref":"readme.html#configuration","title":"Elixir A2S - Configuration","type":"extras"},{"doc":"The features and game servers listed below are unsupported due to disuse and to favor maintainability. Source 2006 / &quot;Pre-Orange Box&quot; servers Would require supporting compression in multipacket responses. Not only adds code complexity, but would require users to have bzip2 installed. Other game servers utilizing multi-packet compression (see above) GoldSrc Servers not using the standard protocol Should impact exceedingly few applications as many GoldSrc servers use the current standard anyway. The Ship Uses proprietary fields only worth supporting out of posterity-sake. A2A_PING Considered deprecated by Valve and is unsupported by many if not almost all most engines. A2S_SERVERQUERY_GETCHALLENGE Only used by a handful of niche games. Normal challenge flow should work anyway.","ref":"readme.html#unsupported-games-features","title":"Elixir A2S - Unsupported Games/Features","type":"extras"},{"doc":"A2S.Client uses Erlang's gen_statem behavior to function and therefore requires the following Logger configuration to report exceptions and crashes: config :logger, handle_otp_reports: true, handle_sasl_reports: true or in a REPL: Logger.configure(handle_otp_reports: true) Logger.configure(handle_sasl_reports: true)","ref":"readme.html#debugging","title":"Elixir A2S - Debugging","type":"extras"},{"doc":"If A2S.Client 's process architecture isn't suitable for your needs, you can use the parsing functions in A2S directly. In order to do so, you'll need to understand the steps necessary to perform A2S queries.","ref":"using-a2s-directly.html","title":"Using A2S Directly","type":"extras"},{"doc":"Each colored box is some internal action taken by your app. Each arrow represents a game server reply. In a perfect world this would be the flow: Where the 'challenge step' is necessary to mitigate A2S queries from being used in reflection attacks. How it actually works: Given the A2S protocol's used by a tons of games in various states of implementation. ( fullscreen ) A2S.Statem may be of good reference for how to handle this in your own app.","ref":"using-a2s-directly.html#a-rough-visual-guide","title":"Using A2S Directly - A rough visual guide","type":"extras"},{"doc":"A2S.Client is specifically optimized for querying numerous game servers on a frequent basis. Official Valve servers may not respond to A2S queries. Some game servers ignore certain fields, filling them with zero values. A2S_INFO was updated relatively recently to the rest of the protocol to mitigate reflection attacks. See Valve's official A2S documentation for more details on A2S.","ref":"using-a2s-directly.html#other-notes","title":"Using A2S Directly - Other notes","type":"extras"}]